#include "raptorpluginloader.h"
//Qt
#include <QDir>
#include <QPluginLoader>
//KDE4
#include <KStandardDirs>
#include <kdebug.h>
#include <KService>
#include <KServiceTypeTrader>

class RaptorPluginLoader::Private
{
	public :
//		Private();
		QString mBasePath;
                QStringList  * PluginList;
                bool mode;
};

RaptorPluginLoader::RaptorPluginLoader(QObject * parent) : QObject(parent)
{
	this->d = new Private();
        d->PluginList = new QStringList();
        d->mode = scan();
}

RaptorPluginLoader::~RaptorPluginLoader()
{
	delete d;
}

bool RaptorPluginLoader::scan()
{
    QStringList raptorlets;
    Raptorlet * raptorlet;
    KService::List offers = KServiceTypeTrader::self()->query("Raptor/Raptorlet");
/*
    QVariantList allArgs;
    allArgs << offers.first()->storageId() << appletId << args;
    QString error;
    //Applet* applet = KService::createInstance<Plasma::Applet>(offers.first(), 0,allArgs, &error);

*/
    foreach (KService::Ptr service , offers) {
    kDebug()<<service->property("Name").toString()<<endl;
    d->PluginList->append(service->property("Name").toString());
    QVariantList allArgs;
    allArgs << service->storageId() << "";
    QString error;


    pluginMap() [ service->property("Name").toString() ] =
        KService::createInstance<Raptorlet>(service, 0,allArgs,&error);
    kDebug()<<error<<endl;
    }
    if ( offers.count() > 0) {
        return true;
    }
    return false;
}

QStringList * RaptorPluginLoader::pluginList()
{
    return d->PluginList;
}

RaptorPluginLoader::PluginMap&
RaptorPluginLoader::pluginMap()
{
    static PluginMap  * map = 0;
    if ( !map ) {
        map = new PluginMap();
    }

    return *map;
}

Raptorlet * RaptorPluginLoader::getDataService(const QString & name)
{
    kDebug()<<d->PluginList<<endl;
    if ( d->PluginList->contains(name)) {
        Raptorlet * raptorlet = pluginMap()[name];
          if (raptorlet ) {
            return raptorlet;
          }
    }
    return NULL;
}



#include "raptorpluginloader.moc"
