#include <QDebug>
#include <QFile>
//#include <KDesktopFile>
//#include <kdesktopfile.h>

#include "manxml.h"

ManXml::ManXml(){
}

ManXml::~ManXml(){
}

QList<Tom> ManXml::parseXMLwithDOM( QDomDocument &d ){

    uid = 0;
    Tom m_tom;
    m_tom.ID =uid++;

    QDomElement tom = d.namedItem("tom").toElement();

    QDomNode tg = tom.firstChild(); 
    for ( ; !tg.isNull(); tg = tg.nextSibling() ) {
    	if ( tg.isElement() && tg.toElement().tagName() == "task_group" ) {

		TomTaskGroup* tomTaskGroup = new TomTaskGroup();
                tomTaskGroup->ID = uid++;
    		QDomElement tg_e = tg.toElement();
		QDomElement task_group_name = tg_e.namedItem("name").toElement();
    		qDebug() << "Task_group name: " + task_group_name.text() + "\n";
		tomTaskGroup->setName(task_group_name.text());

		QDomNode task_ac = tg_e.firstChild();
    		for ( ; !task_ac.isNull(); task_ac = task_ac.nextSibling() ) {
    			if ( task_ac.isElement() && task_ac.toElement().tagName() == "task_action" ) {

				TomTaskAction* tomTaskAction = new TomTaskAction();
                                tomTaskAction->ID = uid++;
    				QDomElement task_ac_e = task_ac.toElement();
				QDomElement task_ac_name = task_ac_e.namedItem("name").toElement();
    				qDebug() << "Task_action name: " + task_ac_name.text() + "\n";
				tomTaskAction->setName(task_ac_name.text());

				QDomNode item = task_ac_e.firstChild();
    				for ( ; !item.isNull(); item = item.nextSibling() ) {
    					if ( item.isElement() && item.toElement().tagName() == "item" ) {


						TomItem* tomItem = new TomItem();
                                                tomItem->ID = uid++;
    						QDomElement item_e = item.toElement();

						QDomElement desktop_file = item_e.namedItem("desktop_file").toElement();
    						qDebug() << "Desktop file: " + desktop_file.text() + "\n";
						tomItem->setDeskFilePath(desktop_file.text());

                                                //KDesktopFile *desktop = new KDesktopFile ( desktop_file.text() );

                                                //tomItem->setIcon(desktop->readIcon());

						//QDomElement item_prog = item_e.namedItem("program").toElement();
    						//qDebug() << "Item Program: " + item_prog.text() + "\n";
						//tomItem->setProgram(item_prog.text());

						//QDomElement item_name = item_e.namedItem("name").toElement();
    						//qDebug() << "Item Name: " + item_name.text() + "\n";
						//tomItem->setName(item_name.text());
                                                //tomItem->setName(desktop->readName());

						//QDomElement item_desc = item_e.namedItem("desc").toElement();
    						//qDebug() << "Item Desc: " + item_desc.text() + "\n";
						//tomItem->setDesc(item_desc.text());
                                                //tomItem->setDesc(desktop->readComment());

						tomTaskAction->tomItems.append(*tomItem);
					}
    				}

				tomTaskGroup->tomTaskActions.append(*tomTaskAction);
			}
    		}
		m_tom.tomTaskGroups.append(*tomTaskGroup);
	}
    }

    QList<Tom> tomGroup;
    tomGroup.append(m_tom);
    return tomGroup;
}

QDomDocument ManXml::updateXml( QList<Tom> tomGroup ){

   QDomDocument doc( "xml" );
   QDomElement root = doc.createElement( "tom" );
   doc.appendChild( root );

   QDomText nodeText;

   Tom tom;
   tom = tomGroup.first();

   QList<TomTaskGroup> tg_list = tom.tomTaskGroups;
   QList<TomTaskGroup>::iterator tg_iter;
   for (tg_iter = tg_list.begin(); tg_iter != tg_list.end(); ++tg_iter){

      QDomElement tg = doc.createElement( "task_group" );
      QDomElement tg_name = doc.createElement( "name" );
      QDomElement tg_name_lc = doc.createElement( "locale" );

      tg_name_lc.setAttribute( "type", "en" );

      nodeText = doc.createTextNode(tg_iter->getName());
      tg_name_lc.appendChild(nodeText);
      tg_name.appendChild(tg_name_lc);
      tg.appendChild(tg_name);

      QList<TomTaskAction> ta_list = tg_iter->tomTaskActions;
      QList<TomTaskAction>::iterator ta_iter;
      for (ta_iter = ta_list.begin(); ta_iter != ta_list.end(); ++ta_iter){

	      QDomElement ta = doc.createElement( "task_action" );
	      QDomElement ta_name = doc.createElement( "name" );
	      QDomElement ta_name_lc = doc.createElement( "locale" );

	      ta_name_lc.setAttribute( "type", "en" );

	      nodeText = doc.createTextNode(ta_iter->getName());
	      ta_name_lc.appendChild(nodeText);
	      ta_name.appendChild(ta_name_lc);
	      ta.appendChild(ta_name);

	      QList<TomItem> itm_list = ta_iter->tomItems;
	      QList<TomItem>::iterator itm_iter;
	      for (itm_iter = itm_list.begin(); itm_iter != itm_list.end(); ++itm_iter){

		      QDomElement itm = doc.createElement( "item" );
		      QDomElement item_desk = doc.createElement( "desktop_file" );

		      nodeText = doc.createTextNode(itm_iter->getDeskFilePath());
		      item_desk.appendChild(nodeText);
		      itm.appendChild(item_desk);
		      ta.appendChild(itm);
	     }
	     tg.appendChild(ta);
      }

      root.appendChild( tg );
   }

   return doc;
}

bool ManXml::saveXml( QDomDocument &doc, QString fname){

   QFile file( fname );
   if( !file.open( QIODevice::WriteOnly ) )
   	return false;

   QTextStream ts( &file );
   ts << doc.toString();

   file.close();
   return true;
}

//
//Not Implemented yet.
/*int ManXml::findTomChild( QList<Tom>* tomGroup, long id, int cmd ){

      QList<Tom>::iterator it;
      for (it = tomGroup.begin(); it != tomGroup.end(); ++it){
          if(it->ID==id){
              switch ( cmd ) {
                          case INSERT :
                              break;

                          case EDIT :
                              break;

                          case DEL :
                              del(tomGroup, it);
                              return 1;
                              break;

                          case FIND :
                              //pvtTom = *it;
                              return 1;
              }
          }
      }
 return 0;
}*/

int ManXml::findTomtaskGrpChild( QList<Tom>* tomGroup, long id, int cmd ) {

      QList<Tom>::iterator it;
      for (it = tomGroup->begin(); it != tomGroup->end(); ++it){

          QList<TomTaskGroup>* tg_list = &(it->tomTaskGroups);
          QList<TomTaskGroup>::iterator tg_iter;
          for (tg_iter = tg_list->begin(); tg_iter != tg_list->end(); ++tg_iter){

              if(tg_iter->ID==id){ qDebug("%d",tg_iter->ID);
                   switch ( cmd ) {
                           case DEL :
                              //del(tg_list, tg_iter);
                               tg_list->erase(tg_iter);
                               return 1;
                               break;

                           case FIND :
                               pvtGroup = &(*tg_iter);
                               return 1;
                   }
               }
          }
      }
 return 0;
}

int ManXml::findTomtaskActionChild( QList<Tom>* tomGroup, long id, int cmd ) {

      QList<Tom>::iterator it;
      for (it = tomGroup->begin(); it != tomGroup->end(); ++it){

          QList<TomTaskGroup>* tg_list = &(it->tomTaskGroups);
          QList<TomTaskGroup>::iterator tg_iter;
          for (tg_iter = tg_list->begin(); tg_iter != tg_list->end(); ++tg_iter){

              QList<TomTaskAction>* ta_list = &(tg_iter->tomTaskActions);
              QList<TomTaskAction>::iterator ta_iter;
              for (ta_iter = ta_list->begin(); ta_iter != ta_list->end(); ++ta_iter){
                  if(ta_iter->ID==id){
                      //qDebug("FOUND"); qDebug() << ta_iter->getName();
                      switch ( cmd ) {
                          case DEL :
                              //del(ta_list, ta_iter);
                              ta_list->erase(ta_iter);
                              return 1;
                              break;

                          case FIND :
                              pvtAction = &(*ta_iter);
                              return 1;
                      }
                  }
              }
          }
      }
 return 0;
}

int ManXml::findTomitemChild( QList<Tom>* tomGroup, long id,  int cmd ) {

    QList<Tom>::iterator it;
    for (it = tomGroup->begin(); it != tomGroup->end(); ++it){

        QList<TomTaskGroup>* tg_list = &(it->tomTaskGroups);
        QList<TomTaskGroup>::iterator tg_iter;
        for (tg_iter = tg_list->begin(); tg_iter != tg_list->end(); ++tg_iter){

            QList<TomTaskAction>* ta_list = &(tg_iter->tomTaskActions);
            QList<TomTaskAction>::iterator ta_iter;
            for (ta_iter = ta_list->begin(); ta_iter != ta_list->end(); ++ta_iter){

                QList<TomItem>* itm_list = &(ta_iter->tomItems);
                QList<TomItem>::iterator itm_iter;
                for (itm_iter = itm_list->begin(); itm_iter != itm_list->end(); ++itm_iter){

                    if(itm_iter->ID==id){
                        switch ( cmd ) {
                          case DEL :
                              //del(itm_list, itm_iter);
                              itm_list->erase(itm_iter);
                              return 1;
                              break;

                          case FIND :
                              pvtItem = &(*itm_iter);
                              return 1;
                       }
                    }
                }
            }
        }
    }
 return 0;
}

/*int ManXml::del( QList<TomTaskAction>* ta_list,  QList<TomTaskAction>::iterator ta_iter) {

  ta_list->erase(ta_iter);
  return 0;
}*/

void ManXml::addNewItem(TomItem tomItem) {

    if(pvtAction != NULL){
      pvtAction->tomItems.append(tomItem);
    }
}

void ManXml::addNewAction(TomTaskAction tomAction) {

    if(pvtGroup != NULL){
      pvtGroup->tomTaskActions.append(tomAction);
    }
}

void ManXml::addNewGroup(QList<Tom>* tomGroup, TomTaskGroup tomTGroup) {

    QList<Tom>::iterator it;
    for (it = tomGroup->begin(); it != tomGroup->end(); ++it){
        it->tomTaskGroups.append(tomTGroup);
    }
}

void ManXml::changeItem(QString tomItem) {

    if(pvtItem != NULL){
      pvtItem->setDeskFilePath(tomItem);
    }
}

void ManXml::changeAction(QString tomAction) {

    if(pvtAction != NULL){
      pvtAction->setName(tomAction);
    }
}

void ManXml::changeGroup(QString tomTGroup) {

    if(pvtGroup != NULL){
      pvtGroup->setName(tomTGroup);
    }
}

TomTaskGroup ManXml::getPvtGroup(){
    return *pvtGroup;
}

TomTaskAction ManXml::getPvtAction(){
    return *pvtAction;
}

TomItem ManXml::getPvtItem(){
    return *pvtItem;
}

long ManXml::getUid(){
   return uid;
}

void ManXml::incrementUid(){
   uid++;
}
