#ifndef MAN_XML
#define MAN_XML

#include <QDomDocument>
#include <QString>

#include "tom.h"
#include "tomitem.h"
#include "tomtaskgroup.h"
#include "tomtaskaction.h"

class ManXml
{
	private:
		long uid;
                enum Commands{ DEL, FIND };
                //int del( QList<TomTaskAction>* ta_list, QList<TomTaskAction>::iterator ta_iter );
                TomTaskGroup* pvtGroup;
                TomTaskAction* pvtAction;
                TomItem* pvtItem;

	public:
		ManXml();
		~ManXml();
		QList<Tom> parseXMLwithDOM( QDomDocument &d );
		//bool addTomTaskAction(TomTaskAction, TomTaskGroup);
                QDomDocument updateXml( QList<Tom> tomGroup );
		bool saveXml( QDomDocument &doc, QString fname);
		//bool updateItem( QList<Tom> tomGroup, QString fname);
                int findTomChild( QList<Tom>* tomGroup, long id,  int cmd );
                int findTomtaskGrpChild( QList<Tom>* tomGroup, long id,  int cmd );
                int findTomtaskActionChild( QList<Tom>* tomGroup, long id, int cmd );
                int findTomitemChild( QList<Tom>* tomGroup, long id,  int cmd );

                void addNewItem(TomItem tomItem);
                void addNewAction(TomTaskAction tomAction);
                void addNewGroup(QList<Tom>* tomGroup, TomTaskGroup tomTGroup);

                void changeItem(QString tomItem);
                void changeAction(QString tomAction);
                void changeGroup(QString tomTGroup);

                TomTaskGroup getPvtGroup();
                TomTaskAction getPvtAction();
                TomItem getPvtItem();

                long getUid();
                void incrementUid();
};

#endif

