#ifndef TOM_EDITOR_FORM_H
#define TOM_EDITOR_FORM_H

#include <QWidget>
#include"ui_tom-edit.h"
#include "manxml.h"

class QPushButton;
class QTextEdit;
class QTreeWidget;
class QLabel;
class QLineEdit;

class TomEditorForm : public QWidget
{
  Q_OBJECT

public:
  TomEditorForm(QWidget *parent = 0);
  void loadFile(QString);
  void generateItemTree();

private slots:
  void about();
  void openFile();
  void treeSelectionChanged();
  void removeItem();
  void saveFile();
  void updateTextView();
  void resetView();
  void btnApplyClicked();
  void insertItem();
  void insertGroup();
  //void listFocusOut();
  void changeItem();

signals:
  void itemListChanged();

private:
  enum Commands{ DEL, FIND };
  QString fullFilePath;
  QWidget* loadUiFile();
  QTextEdit *ui_mainTextEdit;

  QPushButton *ui_openButton;
  QPushButton *ui_saveButton;
  QPushButton *ui_applyButton;
  QPushButton *ui_resetButton;

  QPushButton *ui_delButton;
  QPushButton *ui_editButton;

  QPushButton *ui_addTGButton;
  QPushButton *ui_addTAButton;
  QPushButton *ui_addTIButton;

  QTreeWidget *ui_tree;
  QLabel *ui_label;
  QLabel *ui_labelSelected;

  QLineEdit *fldName;
  QLineEdit *fldProg;
  QLineEdit *fldDesc;
  QLineEdit *fldDeskF;

  QList<Tom> tomGroup;
  QTreeWidgetItem *currenti;
  QHash<int, Tom*> tomhash;
  QHash<int, TomTaskGroup*> taskghash;
  QHash<int, TomTaskAction*> taskahash;
  QHash<int, TomItem*> tomitemhash;
};

#endif 
